import json

from tqdm import tqdm


def file_open_test():
    file = open("data/test_data.json")
    __processor(file)


def file_open():
    file = open("data/IR_data_news_12k.json")
    __processor(file)


def __writer(doc_id, title, content, url, tags, date, category):
    file = open(f"docs/{doc_id}.json", "w")
    dictionary = {
        "doc_id": doc_id,
        "title": title,
        "content": content,
        "tags": tags,
        "date": date,
        "url": url,
        "category": category
    }

    json.dump(dictionary, file)


def __retrieval(data, i, tag):
    try:
        obj_cnt = ''
        lst = list()
        for characters in data[f"{i}"][tag]:
            lst.append(characters)
            obj_cnt = ''.join(lst)
        return obj_cnt
    except Exception as ignore:
        print(f"We have a Exception!! {ignore.with_traceback}")
        pass


def __processor(file):
    data = json.load(file)
    length = len(data)
    doc_ids = list(data.keys())
    for i in tqdm(range(length), desc="Splatted: "):
        doc_id = doc_ids[i]
        title = __retrieval(data, doc_id, "title")
        content = __retrieval(data, doc_id, "content")
        url = __retrieval(data, doc_id, "url")
        tags = __retrieval(data, doc_id, "tags")
        date = __retrieval(data, doc_id, "date")
        category = __retrieval(data, doc_id, "category")

        __writer(doc_id, title, content, url, tags, date, category)
