import json
import os

from parsivar import Normalizer, Tokenizer, FindStems

global stop_words


def debugger(string):
    string = string.replace("\'", "\"")
    # string = string.replace("\"\"\"", "\"\"")
    string = string.replace("\\", " ")
    string = string.replace("\u200c", " ")
    return string


def normalize(tokens):
    if type(tokens) != list:
        tokens = list(tokens)
    for word in tokens:
        if word in stop_words:
            while word in tokens:
                tokens.remove(word)
    return tokens


def token_maker(filename: str):
    counter = int(filename.replace(".json", ""))
    filepath = os.path.join("./docs", filename)
    file = open(filepath, "r")
    obj = json.load(file)
    obj_cnt = ''
    lst = list()
    for ch in obj["content"]:
        lst.append(ch)
        obj_cnt = ''.join(lst)
    normalizer = Normalizer()
    pars_tokenizer = Tokenizer()
    my_stemmer = FindStems()
    normal_txt = normalizer.normalize(obj_cnt)
    tokens = pars_tokenizer.tokenize_words(normal_txt)
    output = dict()
    position = 0
    tokens = normalize(tokens)

    # word = tokens[position]
    for word in tokens:
        word = my_stemmer.convert_to_stem(word)
        if word.__contains__('&'):
            x = word.index('&')
            word = word[0:x]

        if not output.keys().__contains__(word):  # Create Postings list
            output.update(
                {str(word): {str(counter): [position]}
                 }
            )
        else:
            if output[word].keys().__contains__(position):
                output[word][str(counter)].append(position)
            else:
                output[word].update(
                    {str(counter): [position]}
                )
        position = position + 1

    filename = str(filename)
    tk_fl = open(f"document tokens/{filename}", "w", encoding="utf-8")
    str_out = str(output)
    str_out = debugger(str_out)
    tk_fl.write(str_out)


def __starter(upper_bound, files):
    counter = 0
    pre_percent = 0
    print("0% is tokenized!")
    for f in files:
        new_percent = int((counter / upper_bound) * 100)
        token_maker(str(f))
        if new_percent != pre_percent:
            print(f"{new_percent}% is tokenized!")
            pre_percent = new_percent
        counter = counter + 1


def get_file_test(files):
    __starter(23, files)


def get_file(files):
    __starter(12201, files)
